const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const bom_lines = sequelize.define(
    'bom_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

line_number: {
        type: DataTypes.INTEGER,
      
      

      },

quantity_per: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_rate: {
        type: DataTypes.DECIMAL,
      
      

      },

issue_method: {
        type: DataTypes.ENUM,
      
      

        values: [

"manual",


"backflush"

        ],

      },

remarks: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  bom_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.bom_lines.belongsTo(db.bom_headers, {
      as: 'bom_header',
      foreignKey: {
        name: 'bom_headerId',
      },
      constraints: false,
    });

    db.bom_lines.belongsTo(db.items, {
      as: 'component_item',
      foreignKey: {
        name: 'component_itemId',
      },
      constraints: false,
    });

    db.bom_lines.belongsTo(db.uoms, {
      as: 'uom',
      foreignKey: {
        name: 'uomId',
      },
      constraints: false,
    });




    db.bom_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.bom_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return bom_lines;
};


